用于leetcode算法调试， 包含一些常用数据结构的操作，比如将列表转成树、链表等

算法的模板放在`src`文件夹下
测试程序放在`tests`文件夹下
# 目录
## 算法基础
[差分数组](src/basic/array_of_difference.py)
[倍增](src/basic/binary_lifting.py)
[二分查找](src/basic/binary_search.py)

## 数据结构
[树状数组](src/data_structure/bit.py)
[并查集](src/data_structure/dsu.py)
[线段树](src/data_structure/segment_tree.py)
[栈](src/data_structure/stack.py)
[单调栈](src/data_structure//monotonic_stack.py)
[单调队列](src/data_structure/monotonic_queue.py)

## 动态规划
[数位dp](src/dynamic_programming/digital_dp.py)

## 图论
[广度优先遍历](src/graph/bfs.py)
[最近公共祖先LCA](src/graph/lca.py)
[最小生成树](src/graph/minimum_spanning_tree.py)
[最短路径](src/graph/smallest_routes.py)
[二叉树](src/graph/binary_tree.py)
[二叉搜索树](src/graph/binary_search_tree.py)
[拓扑排序](src/graph/topological_sorting.py)

## 数学
[常用公式](src/mathematic/common_formula.py)
[快速幂](src/mathematic/fast_power.py)
[费马小定理](src/mathematic/fermat_little_theorem.py)
[找质因数](src/mathematic/find_prime_factor.py)
[最大公因数](src/mathematic/greatest_common_divisor.py)
[判断质数](src/mathematic/judge_prime.py)
[筛选质数](src/mathematic/filter_prime.py)
[组合数求模](src/mathematic/combinatorics.py)

## 杂项
[离散化](src/misc/discretization.py)
[双指针](src/misc/double_pointer.py)

## 搜索
[回溯](src/search/backtrace.py)




持续更新中...